<?php

/**
 * Reminder plugin
 *
 *
 * Created: 2007-02-04
 * Last update: 2007-03-25
 *
 * @link http://deboutv.free.fr/mantis/
 * @author DEBOUT Vincent  <deboutv@free.fr>
 */

require_once( dirname( dirname( dirname( __FILE__ ) ) ) . DIRECTORY_SEPARATOR . 'core.php' );
require_once( dirname( __FILE__ ) . DIRECTORY_SEPARATOR . 'core' . DIRECTORY_SEPARATOR . 'reminder_api.php' );

$t_project_id = gpc_get_int( 'project_id', -1 );
if ( isset( $_SERVER['argv'][1] ) && eregi( 'project_id=', $_SERVER['argv'][1] ) ) {
    $t_project_id = explode( '=', $_SERVER['argv'][1] );
    $t_project_id = $t_project_id[1];
    $t_projects[0]['id'] = $t_project_id;
} elseif ( $t_project_id > 0 ) {
    $t_projects[0]['id'] = $t_project_id;
} else {
    $t_projects = project_get_all_rows();
    $t_projects[0]['id'] = 0;
}

$t_mail = new PHPMailer();
$t_mail->PluginDir = PHPMAILER_PATH;
switch ( config_get( 'phpMailer_method' ) ) {
  case 0:
    $t_mail->IsMail();
    break;
  case 1:
    $t_mail->IsSendmail();
    break;
  case 2:
    $t_mail->IsSMTP();
    $t_mail->SMTPKeepAlive = true;
    if( is_null( $g_phpMailer_smtp ) )  {
        register_shutdown_function( 'email_smtp_close' );
    } else {
        $t_mail->smtp = $g_phpMailer_smtp;
    }
    break;
}
$t_mail->WordWrap = 80;
$t_mail->Priority = config_get( 'mail_priority' );
$t_mail->Host = config_get( 'smtp_host' );
$t_mail->From = config_get( 'from_email' );
$t_mail->Sender = config_get( 'return_path_email' );
$t_mail->FromName = '';
if ( !is_blank( config_get( 'smtp_username' ) ) ) {
    $t_mail->SMTPAuth = true;
    $t_mail->Username = config_get( 'smtp_username' );
    $t_mail->Password = config_get( 'smtp_password' );
}

foreach( $t_projects as $t_project ) {
    $t_project_id = $t_project['id'];
    if ( config_get( 'plugins_reminder_enable', PLUGINS_REMINDER_ENABLE_DEFAULT, NO_USER, $t_project_id ) == ON ) {
        if ( isset( $_SERVER['argc'] ) ) {
            $t_ok = true;
        } else {
            if ( !isset( $_SERVER['REMOTE_ADDR'] ) || config_get( 'plugins_reminder_html_enable', PLUGINS_REMINDER_HTML_ENABLE_DEFAULT, NO_USER, $t_project_id ) == OFF ) {
                $t_ok = false;
            } else {
                $t_ip = config_get( 'plugins_reminder_html_host', PLUGINS_REMINDER_HTML_HOST_DEFAULT, NO_USER, $t_project_id );
                if ( !eregi( '^[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+', $t_ip ) ) {
                    $t_ip = gethostbyname( $t_ip );
                }
                if ( $_SERVER['REMOTE_ADDR'] != $t_ip ) {
                    $t_ok = false;
                } else {
                    $t_ok = true;
                }
            }
        }
        if ( $t_ok ) {
            $t_format = config_get( 'plugins_reminder_format', PLUGINS_REMINDER_FORMAT_DEFAULT, NO_USER, $t_project_id );
            if ( $t_format == REMINDER_TEXT ) {
                $t_mail->IsHTML( false );
            } else {
                $t_mail->IsHTML( true );
            }
            $t_mail->Subject = config_get( 'plugins_reminder_subject_title', PLUGINS_REMINDER_SUBJECT_TITLE_DEFAULT, NO_USER, $t_project_id );

            $t_user_ids = config_get( 'plugins_reminder_users', array(), NO_USER, $t_project_id );
            $t_exclude_dates = explode( ';', config_get( 'plugins_reminder_dates', PLUGINS_REMINDER_DATES_DEFAULT, NO_USER, $t_project_id ) );
            $t_dont_send = false;
            $t_current_date = getdate( time() );
            foreach( $t_exclude_dates as $t_date ) {
                if ( trim( $t_date ) != '' ) {
                    $t_date = explode( ',', $t_date );
                    $t_equal = true;
                    foreach( $t_date as $t_elt ) {
                        $t_elt = explode( '=>', $t_elt );
                        if ( isset( $t_current_date[trim( $t_elt[0] )] ) && $t_current_date[trim( $t_elt[0] )] != trim( $t_elt[1] ) ) {
                            $t_equal = false;
                        }
                    }
                    if ( $t_equal ) {
                        $t_dont_send = true;
                    }
                }
            }
            foreach( $t_user_ids as $t_user_id ) {
                if ( user_is_enabled( $t_user_id ) ) {
                    $t_send = false;
                    $t_send_excepted = false;
                    $t_language = user_pref_get_language( $t_user_id );
                    lang_push( $t_language );
                    $t_mail->SetLanguage( lang_get( 'phpmailer_language', $t_language ), PHPMAILER_PATH . 'language' . DIRECTORY_SEPARATOR );
                    $t_mail->CharSet = lang_get( 'charset', $t_language );
                    $t_mail->ClearAllRecipients();
                    $t_mail->AddAddress( user_get_email( $t_user_id ), user_get_realname( $t_user_id ) );
                    if ( $t_format == REMINDER_TEXT ) {
                        $t_mail->Body = reminder_get_body( $t_send, $t_send_excepted, $t_user_id, 'text', $t_project_id );
                    } else {
                        $t_mail->Body = reminder_get_body( $t_send, $t_send_excepted, $t_user_id, 'html', $t_project_id );
                    }
                    if ( $t_format == REMINDER_TEXT_HTML ) {
                        $t_mail->AltBody = reminder_get_body( $t_send, $t_send_excepted, $t_user_id, 'text', $t_project_id );
                    }
                    if ( $t_send_excepted ) {
                        $t_send = true;
                    } elseif ( $t_dont_send ) {
                        $t_send = false;
                    }
                    if ( $t_send ) {
                        if ( !$t_mail->Send() ) {
                            echo "PROBLEMS SENDING MAIL TO: $p_recipient<br />";
                            echo 'Mailer Error: ' . $t_mail->ErrorInfo . '<br />';
                        }
                    }                   
                    lang_pop();
                }
            }       
            if ( !is_null( $t_mail->smtp ) )  {
                $g_phpMailer_smtp = $t_mail->smtp;
            }
        }
    }
}

header( 'Location: ' . config_get( 'path' ) );

?>
